using System;
using System.Data;
using System.Text;
using System.Data.SqlClient;
using ZXDT.DBUtility;

namespace ZXDT.CallCenter.DAL
{
    /// <summary>
    /// 数据访问类:T_HW_DutyNumber
    /// </summary>
    public partial class T_HW_DutyNumber
    {
        public T_HW_DutyNumber()
        { }
        #region  BasicMethod
        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists(int F_ID)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) from T_HW_DutyNumber");
            strSql.Append(" where F_ID=@F_ID");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_ID", SqlDbType.Int,4)
            };
            parameters[0].Value = F_ID;

            return DbHelperSQL.Exists(strSql.ToString(), parameters);
        }


        /// <summary>
        /// 增加一条数据
        /// </summary>
        public int Add(ZXDT.CallCenter.Model.T_HW_DutyNumber model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into T_HW_DutyNumber(");
            strSql.Append("F_DutyNumber,F_Groupid,F_LastCallTime,F_ZBTime,F_Remark,F_AddTime,F_AddUser,F_State,F_Group)");
            strSql.Append(" values (");
            strSql.Append("@F_DutyNumber,@F_Groupid,@F_LastCallTime,@F_ZBTime,@F_Remark,@F_AddTime,@F_AddUser,@F_State,@F_Group)");
            strSql.Append(";select @@IDENTITY");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_DutyNumber", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_Groupid", SqlDbType.Int,4),
                    new SqlParameter("@F_LastCallTime", SqlDbType.DateTime),
                    new SqlParameter("@F_ZBTime", SqlDbType.DateTime),
                    new SqlParameter("@F_Remark", SqlDbType.NText),
                    new SqlParameter("@F_AddTime", SqlDbType.DateTime),
                    new SqlParameter("@F_AddUser", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_State", SqlDbType.Int,4),
                    new SqlParameter("@F_Group", SqlDbType.VarChar,50)};
            parameters[0].Value = model.F_DutyNumber;
            parameters[1].Value = model.F_Groupid;
            parameters[2].Value = model.F_LastCallTime;
            parameters[3].Value = model.F_ZBTime;
            parameters[4].Value = model.F_Remark;
            parameters[5].Value = model.F_AddTime;
            parameters[6].Value = model.F_AddUser;
            parameters[7].Value = model.F_State;
            parameters[8].Value = model.F_Group;

            object obj = DbHelperSQL.GetSingle(strSql.ToString(), parameters);
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(ZXDT.CallCenter.Model.T_HW_DutyNumber model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update T_HW_DutyNumber set ");
            strSql.Append("F_DutyNumber=@F_DutyNumber,");
            strSql.Append("F_Groupid=@F_Groupid,");
            strSql.Append("F_LastCallTime=@F_LastCallTime,");
            strSql.Append("F_ZBTime=@F_ZBTime,");
            strSql.Append("F_Remark=@F_Remark,");
            strSql.Append("F_AddTime=@F_AddTime,");
            strSql.Append("F_AddUser=@F_AddUser,");
            strSql.Append("F_State=@F_State,");
            strSql.Append("F_Group=@F_Group");
            strSql.Append(" where F_ID=@F_ID");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_DutyNumber", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_Groupid", SqlDbType.Int,4),
                    new SqlParameter("@F_LastCallTime", SqlDbType.DateTime),
                    new SqlParameter("@F_ZBTime", SqlDbType.DateTime),
                    new SqlParameter("@F_Remark", SqlDbType.NText),
                    new SqlParameter("@F_AddTime", SqlDbType.DateTime),
                    new SqlParameter("@F_AddUser", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_State", SqlDbType.Int,4),
                    new SqlParameter("@F_Group", SqlDbType.VarChar,50),
                    new SqlParameter("@F_ID", SqlDbType.Int,4)};
            parameters[0].Value = model.F_DutyNumber;
            parameters[1].Value = model.F_Groupid;
            parameters[2].Value = model.F_LastCallTime;
            parameters[3].Value = model.F_ZBTime;
            parameters[4].Value = model.F_Remark;
            parameters[5].Value = model.F_AddTime;
            parameters[6].Value = model.F_AddUser;
            parameters[7].Value = model.F_State;
            parameters[8].Value = model.F_Group;
            parameters[9].Value = model.F_ID;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int F_ID)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_HW_DutyNumber ");
            strSql.Append(" where F_ID=@F_ID");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_ID", SqlDbType.Int,4)
            };
            parameters[0].Value = F_ID;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 批量删除数据
        /// </summary>
        public bool DeleteList(string F_IDlist)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_HW_DutyNumber ");
            strSql.Append(" where F_ID in (" + F_IDlist + ")  ");
            int rows = DbHelperSQL.ExecuteSql(strSql.ToString());
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public ZXDT.CallCenter.Model.T_HW_DutyNumber GetModel(int F_ID)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 F_ID,F_DutyNumber,F_Groupid,F_LastCallTime,F_ZBTime,F_Remark,F_AddTime,F_AddUser,F_State,F_Group from T_HW_DutyNumber ");
            strSql.Append(" where F_ID=@F_ID");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_ID", SqlDbType.Int,4)
            };
            parameters[0].Value = F_ID;

            ZXDT.CallCenter.Model.T_HW_DutyNumber model = new ZXDT.CallCenter.Model.T_HW_DutyNumber();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                return DataRowToModel(ds.Tables[0].Rows[0]);
            }
            else
            {
                return null;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public ZXDT.CallCenter.Model.T_HW_DutyNumber DataRowToModel(DataRow row)
        {
            ZXDT.CallCenter.Model.T_HW_DutyNumber model = new ZXDT.CallCenter.Model.T_HW_DutyNumber();
            if (row != null)
            {
                if (row["F_ID"] != null && row["F_ID"].ToString() != "")
                {
                    model.F_ID = int.Parse(row["F_ID"].ToString());
                }
                if (row["F_DutyNumber"] != null)
                {
                    model.F_DutyNumber = row["F_DutyNumber"].ToString();
                }
                if (row["F_Groupid"] != null && row["F_Groupid"].ToString() != "")
                {
                    model.F_Groupid = int.Parse(row["F_Groupid"].ToString());
                }
                if (row["F_LastCallTime"] != null && row["F_LastCallTime"].ToString() != "")
                {
                    model.F_LastCallTime = DateTime.Parse(row["F_LastCallTime"].ToString());
                }
                if (row["F_ZBTime"] != null && row["F_ZBTime"].ToString() != "")
                {
                    model.F_ZBTime = DateTime.Parse(row["F_ZBTime"].ToString());
                }
                if (row["F_Remark"] != null)
                {
                    model.F_Remark = row["F_Remark"].ToString();
                }
                if (row["F_AddTime"] != null && row["F_AddTime"].ToString() != "")
                {
                    model.F_AddTime = DateTime.Parse(row["F_AddTime"].ToString());
                }
                if (row["F_AddUser"] != null)
                {
                    model.F_AddUser = row["F_AddUser"].ToString();
                }
                if (row["F_State"] != null && row["F_State"].ToString() != "")
                {
                    model.F_State = int.Parse(row["F_State"].ToString());
                }
                if (row["F_Group"] != null)
                {
                    model.F_Group = row["F_Group"].ToString();
                }
            }
            return model;
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select F_ID,F_DutyNumber,F_Groupid,F_LastCallTime,F_ZBTime,F_Remark,F_AddTime,F_AddUser,F_State,F_Group ");
            strSql.Append(" FROM T_HW_DutyNumber ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ");
            if (Top > 0)
            {
                strSql.Append(" top " + Top.ToString());
            }
            strSql.Append(" F_ID,F_DutyNumber,F_Groupid,F_LastCallTime,F_ZBTime,F_Remark,F_AddTime,F_AddUser,F_State,F_Group ");
            strSql.Append(" FROM T_HW_DutyNumber ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            strSql.Append(" order by " + filedOrder);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获取记录总数
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) FROM T_HW_DutyNumber ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            object obj = DbHelperSQL.GetSingle(strSql.ToString());
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("SELECT * FROM ( ");
            strSql.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                strSql.Append("order by T." + orderby);
            }
            else
            {
                strSql.Append("order by T.F_ID desc");
            }
            strSql.Append(")AS Row, T.*  from T_HW_DutyNumber T ");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                strSql.Append(" WHERE " + strWhere);
            }
            strSql.Append(" ) TT");
            strSql.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /*
		/// <summary>
		/// 分页获取数据列表
		/// </summary>
		public DataSet GetList(int PageSize,int PageIndex,string strWhere)
		{
			SqlParameter[] parameters = {
					new SqlParameter("@tblName", SqlDbType.VarChar, 255),
					new SqlParameter("@fldName", SqlDbType.VarChar, 255),
					new SqlParameter("@PageSize", SqlDbType.Int),
					new SqlParameter("@PageIndex", SqlDbType.Int),
					new SqlParameter("@IsReCount", SqlDbType.Bit),
					new SqlParameter("@OrderType", SqlDbType.Bit),
					new SqlParameter("@strWhere", SqlDbType.VarChar,1000),
					};
			parameters[0].Value = "T_HW_DutyNumber";
			parameters[1].Value = "F_ID";
			parameters[2].Value = PageSize;
			parameters[3].Value = PageIndex;
			parameters[4].Value = 0;
			parameters[5].Value = 0;
			parameters[6].Value = strWhere;	
			return DbHelperSQL.RunProcedure("UP_GetRecordByPage",parameters,"ds");
		}*/

        #endregion  BasicMethod
        #region  ExtensionMethod

        #endregion  ExtensionMethod
    }
}

